clc
clear all
close all

%%%% Computing the ACT for a RW


% Read me: change these numbers

Iter = 10; % number of iterations for each N
VecN = [10000:10^4:30000]; % range of values for rho


% parameters
sig_sq = 1;

ACT  = [];
Var  = [];


for N = VecN
N

Avtemp = [];

for ii=1:Iter

ii

% random white noise
sig = sig_sq^0.5;
eps = sig*randn(N,1);

% lambda series
lambda = [];
temp   = 0;
for i = 1:N
    temp1  = temp+eps(i);
    lambda = [lambda temp1];
    temp   = temp1;
end

x = lambda;
Av_x   = sum(x)/length(x);
Sig2_x = sum((x-Av_x).^2)/length(x);


% calculate ACT
temp = 0;

if x(1) > Av_x
    temp = 1;
end

TvecA = [];
TvecB = [];
T1    = 1 ;

for j = 2:N
    if temp == 0
        if x(j) > Av_x
            temp = 1;
            TvecB = [TvecB j-T1];
            T1 = j;
        end
    end
    
    if temp == 1
        if x(j) < Av_x
            temp = 0;
            TvecA = [TvecA j-T1];
            T1 = j;
        end
    end
end 
    
Avtemp = [Avtemp (sum(TvecA)+sum(TvecB))/(length(TvecA)+length(TvecB))];

end

TempAv = sum(Avtemp)/length(Avtemp);

ACT = [ACT TempAv];
Var  = [Var sum((Avtemp-TempAv).^2)/length(Avtemp)];

save('RW')

end

figure
hold on

plot(VecN, ACT, 'k--', 'LineWidth',2)
plot(VecN, ACT+2*Var.^0.5/Iter^0.5, 'g--', 'LineWidth',2)
plot(VecN, ACT-2*Var.^0.5/Iter^0.5, 'g--', 'LineWidth',2)

title('ACT for RW','FontSize',16,'Interpreter','Latex')
xlabel('$N$','FontSize',16,'Interpreter','Latex')
ylabel('ACT','FontSize',16,'Interpreter','Latex')
grid on

hold off






