clc
clear all
close all

%%%% ACT for various Ns
%%%%

% parameters
k0     = 1        ;
sig_sq = 0.00712^2;

VN   = [500 1000:1000:10000]; %range of values for N
Iter = 1000;

omega  = 1   ;
rho    = 1   ;
alpha  = 0.36;
beta   = 0.99;

No = 0; 

ACT  = zeros(5,length(VN));
SD   = zeros(5,length(VN));

for Index = 1

Index

for jj = 1:length(VN)

N = VN(jj)

ACT1 = [];
ACT2 = [];

for ii = 1:Iter

% random white noise
sig = sig_sq^0.5;
eps = sig*randn(N,1);

% lambda series
lambda = [];
temp = 0;
for i = 1:N
    temp1 = rho*temp+eps(i);
    lambda = [lambda temp1];
    temp = temp1;
end

% k series
k = (alpha*beta*exp(0.5*sig_sq))^(1/(1-alpha)); %kss to start with
temp = (alpha*beta*exp(0.5*sig_sq))^(1/(1-alpha));
for i = 1:(N-1)
    ktemp = alpha*beta*temp^alpha*exp(lambda(i));
    k = [k ktemp];
    temp = ktemp;
end

% return and prices series
pte = alpha*beta*k.^(alpha).*exp(lambda);
ptb = beta*exp(sig_sq/2)*(alpha*beta)^(-alpha).*k.^(alpha-alpha^2).*exp((1-alpha-rho)*lambda);
rte = alpha*k.^(alpha-1).*exp(lambda);
rtb = 1./ptb-1;
rtp = rte-rtb;

Series = [pte; ptb; rte; rtb; rtp];
x = Series(Index,:);

Av_x = sum(x)/length(x);
Sig2_x = sum((x-Av_x).^2)/length(x);

temp = 0;

if x(1) > Av_x
    temp = 1;
end

TvecA = [];
TvecB = [];
T1    = 1 ;

for j = 2:N
    if temp == 0
        if x(j) > Av_x
            temp = 1;
            TvecB = [TvecB j-T1];
            T1 = j;
        end
    end
    
    if temp == 1
        if x(j) < Av_x
            temp = 0;
            TvecA = [TvecA j-T1];
            T1 = j;
        end
    end
end 
    
Temp1  = (sum(TvecA)+sum(TvecB))/(length(TvecA)+length(TvecB));

nn     = length(x);

if length(TvecA) == 0

TvecA = [nn-1-TvecB(1)];

end

if length(TvecB) == 0

TvecB = [nn-1-TvecA(1)];

end

ACT1  = [ACT1 (sum(TvecA)+sum(TvecB))/(length(TvecA)+length(TvecB))];
ACT2  = [ACT2 N/(length(TvecA)+length(TvecB))];

end

ACT(Index, jj) = (mean(ACT1)+mean(ACT2))/2;
SD(Index, jj)  = std((ACT1+ACT2)/2)       ;


end

end

Title1 = ["ACT for $p^e_t$", "ACT for $p^b_t$", "ACT for $r^e_t$", "ACT for $r^b_t$", "ACT for $r^p_t$"];
Title1SD = ["SD for $p^e_t$", "SD for $p^b_t$", "SD for $r^e_t$", "SD for $r^b_t$", "SD for $r^p_t$"];

for ii = 1:Index
    
figure
plot(VN, ACT(ii,:), 'k', 'LineWidth',1.5)

% title(Title1(ii),'FontSize',16,'Interpreter','Latex')
xlabel('$N$','FontSize',16,'Interpreter','Latex')
ylabel('$\widehat{ACT}$','FontSize',16,'Interpreter','Latex')

grid on

saveas(gcf, Title1(ii),'jpeg')
saveas(gcf, Title1(ii),'fig')

figure

plot(VN, SD(ii,:), 'k', 'LineWidth',1.5)

% title(Title1SD(ii),'FontSize',16,'Interpreter','Latex')
xlabel('$N$','FontSize',16,'Interpreter','Latex')
ylabel('SE','FontSize',16,'Interpreter','Latex')

grid on

saveas(gcf, Title1SD(ii),'jpeg')
saveas(gcf, Title1SD(ii),'fig')


end

save('ACTVariousN')
