clc
clear all
close all

%%% The analytical correlation for different rhos


% parameters
k0 = 1;
sig_sq = 0.01;

JN = 500;
omega = 1;
rho = 0.5;
alpha = 0.36;
alpha1 = alpha-1;
beta = 0.99;


figure
hold on

for rho = [0:0.2:0.9 0.95]
    
% pte
Var = exp(sig_sq *(alpha^2/(1-alpha^2)+rho^2/(1-rho^2)-2*alpha*rho/(1-alpha*rho))/(alpha-rho)^2)-1;
Cov = [];

for j = 1:JN
    Cov = [Cov exp(sig_sq * ( alpha^(2+j)/(1-alpha^2) + rho^(2+j)/(1-rho^2) -alpha*rho*(alpha^j+rho^j)/(1-alpha*rho) )/ (alpha-rho)^2 )-1 ];
end

V = [];
for J = 1:JN
    Coeff = 2*((J-1):(-1):1)/J;
    V = [V 1+sum(Coeff.*Cov(1:(J-1))/Var)];
end

plot(V)
xlabel("J")
ylabel("V(J)")

end

hold off




%ptb
JN = 500;
omega = 1;
rho = 0.5;
alpha = 0.36;
beta = 0.99;
sig_sq = 0.01;

n1 = 100;
Ind = 1:n1;

figure
hold on

for rho = [0:0.2:0.9 0.95]
    
% ptb
Var = exp(sig_sq *(sum( (((alpha.^Ind-alpha.^(Ind+1))-(rho.^Ind-rho.^(Ind+1)))./(alpha-rho)) .^2 )))-1;
Cov = [];

for j = 1:JN
    Cov = [Cov exp(sig_sq *(sum( (((alpha.^Ind-alpha.^(Ind+1))-(rho.^Ind-rho.^(Ind+1)))./(alpha-rho)) .* (((alpha.^(Ind+j)-alpha.^(Ind+j+1))-(rho.^(Ind+j)-rho.^(Ind+j+1)))./(alpha-rho)) )))-1 ];
end

V = [];

for J = 1:JN
    Coeff = 2*((J-1):(-1):1)/J;
    V = [V 1+sum(Coeff.*Cov(1:(J-1))/Var)];
end

plot (V)
xlabel("J")
ylabel("V(J)")

end

hold off



%rte
JN = 500;
omega = 1;
rho = 0.5;
alpha = 0.36;
beta = 0.99;
sig_sq = 0.01;

n1 = 100;
Ind = 1:n1;


figure
hold on
for rho = [0:0.2:0.9 0.95]
    
Var = exp( sig_sq *(1 + sum( (((alpha.^Ind-alpha.^(Ind+1))-(rho.^Ind-rho.^(Ind+1)))./(alpha-rho)) .^2 )))-1;
Cov = [];

for j = 1:JN
    Cov = [Cov exp(sig_sq *( -1*(((alpha.^(j)-alpha.^(j+1))-(rho.^(j)-rho.^(j+1)))./(alpha-rho)) + sum( (((alpha.^Ind-alpha.^(Ind+1))-(rho.^Ind-rho.^(Ind+1)))./(alpha-rho)) .* (((alpha.^(Ind+j)-alpha.^(Ind+j+1))-(rho.^(Ind+j)-rho.^(Ind+j+1)))./(alpha-rho)) )))-1 ];
end

V = [];

for J = 1:JN
    Coeff = 2*((J-1):(-1):1)/J;
    V = [V 1+sum(Coeff.*Cov(1:(J-1))/Var)];
end

sum(Cov(1:(J-1)))
plot (V)
xlabel("J")
ylabel("V(J)")

end

hold off











