clc
clear all
close all

%%%% first task: replicate table 5.1
%%%%

% parameters
k0     = 1   ;
sig2   = 0.00712^2;
sig    = sig2^0.5;
N      = 100; %length of time series
omega  = 1   ;
alpha  = 0.36;
beta   = 0.99;

V = [];

NVec = 1:N;

Name = ["Impulse response for $\rho = 0$", "Impulse response for $\rho = 0.2$", "Impulse response for $\rho = 0.4$", "Impulse response for $\rho = 0.6$", "Impulse response for $\rho = 0.8$", "Impulse response for $\rho = 0.95$"];
NameFile = ["rho0", "rho2", "rho4", "rho6", "rho8", "rho95"];

%rhoV = [0:0.2:0.9 0.95];
rhoV = [0 0.6 0.95];

for ii = 1:length(rhoV);

rho = rhoV(ii);

% lambda series
lambda = sig*rho.^(NVec-1);

% k series
k    = [(alpha*beta*exp(0.5*sig2))^(1/(1-alpha))]; % kss to start with
temp = (alpha*beta*exp(0.5*sig2))^(1/(1-alpha))  ;
for i = 1:(N-1)
    ktemp = alpha*beta*temp^alpha*exp(lambda(i));
    k     = [k ktemp];
    temp  = ktemp;
end

[a b] = max(k);
x = (a+k(1))/2;
k1 = k(b:end);
[aa bb] = min(abs(k1-x));

rho
HL = bb+b-2

figure
hold on

plot(NVec, k, 'k', 'LineWidth',1.5)

title([Name(ii) "Half life is " + num2str(HL)],'FontSize',16,'Interpreter','Latex')
xlabel('$n$','FontSize',16,'Interpreter','Latex')
ylabel('$p^e$','FontSize',16,'Interpreter','Latex','Rotation',0)

grid on
hold off

saveas(gcf, NameFile(ii),'jpeg')


end





