clc
clear all
close all

%%%% first task: replicate table 5.1
%%%%

% parameters
k0     = 1   ;
sig2   = 0.00712^2;
N      = 10^5; %length of time series
omega  = 1   ;
alpha  = 0.36;
beta   = 0.99;

Corr  = zeros(5,7); % autocorrelation matrix for different series (rows) and different rows (columns)

for Index = 1:5 
    
Index % Index correponds to quantity of interest (p_t^e,...)
    
CorrTemp=[];

for rho = [0:0.2:0.9 0.95 1]

rho

% random white noise
sig = sig2^0.5      ;
eps = sig*randn(N,1);

% lambda series
lambda = [];
temp = 0   ;
for i = 1:N
    temp1  = rho*temp+eps(i);
    lambda = [lambda temp1];
    temp   = temp1;
end

% k series
k    = [(alpha*beta*exp(0.5*sig2))^(1/(1-alpha))]; % kss to start with
temp = (alpha*beta*exp(0.5*sig2))^(1/(1-alpha))  ;
for i = 1:(N-1)
    ktemp = alpha*beta*temp^alpha*exp(lambda(i));
    k     = [k ktemp];
    temp  = ktemp;
end

% return and prices series
pte = alpha*beta*k.^(alpha).*exp(lambda);
ptb = beta*exp(sig2/2)*(alpha*beta)^(-alpha).*k.^(alpha-alpha^2).*exp((1-alpha-rho)*lambda);
rte = alpha*k.^(alpha-1).*exp(lambda);
rtb = 1./ptb-1;
rtp = rte-rtb;
VV  = [pte; ptb; rte; rtb; rtp];

i = Index;
x = VV(i,:);

Av_x = sum(x)/length(x);
Sig2_x = sum((x-Av_x).^2)/length(x);

Corr_x = (sum(x(2:end).*x(1:(end-1)))./(length(x)-1)-Av_x^2)/Sig2_x;
CorrTemp = [CorrTemp Corr_x];

end

Corr(i,:) = CorrTemp;

end

Corr



