clc
clear all
close all

%%%% replicate table 5.1 for a given N with the SD of ACT
%%%%

% parameters
k0     = 1        ;
sig_sq = 0.00712^2;

N      = 10^4 ; % length of time series
Iter   = 1000;


omega  = 1   ;
alpha  = 0.36;
beta   = 0.99;

No = 0; 

ACT  = zeros(5,6); 
ACTA = zeros(5,6); 
ACTB = zeros(5,6); 
SD   = zeros(5,6); 
SDA  = zeros(5,6); 
SDB  = zeros(5,6);

% rho = [0:0.2:0.9 0.95]
for rho = [1]

rho

No = No+1;

for Index = 1:5

Index; % Index means which return or price is calculated (a new draw)

ACT1    = [];
ACT2    = [];

ACTA1   = [];
ACTA2   = [];

ACTB1   = [];
ACTB2   = [];

for ii = 1:Iter

ii

% random white noise
sig = sig_sq^0.5;
eps = sig*randn(N,1);

% lambda series
lambda = [];
temp = 0;
for i = 1:N
    temp1 = rho*temp+eps(i);
    lambda = [lambda temp1];
    temp = temp1;
end

% k series
k = (alpha*beta*exp(0.5*sig_sq))^(1/(1-alpha)); %kss to start with
temp = (alpha*beta*exp(0.5*sig_sq))^(1/(1-alpha));
for i = 1:(N-1)
    ktemp = alpha*beta*temp^alpha*exp(lambda(i));
    k = [k ktemp];
    temp = ktemp;
end

% return and prices series
pte = alpha*beta*k.^(alpha).*exp(lambda);
ptb = beta*exp(sig_sq/2)*(alpha*beta)^(-alpha).*k.^(alpha-alpha^2).*exp((1-alpha-rho)*lambda);
rte = alpha*k.^(alpha-1).*exp(lambda);
rtb = 1./ptb-1;
rtp = rte-rtb;

Series = [pte; ptb; rte; rtb; rtp];
x = Series(Index,:);

Av_x = sum(x)/length(x);
Sig2_x = sum((x-Av_x).^2)/length(x);

temp = 0;

if x(1) > Av_x
    temp = 1;
end

TvecA = [];
TvecB = [];
T1    = 1 ;

for j = 2:N
    if temp == 0
        if x(j) > Av_x
            temp = 1;
            TvecB = [TvecB j-T1];
            T1 = j;
        end
    end
    
    if temp == 1
        if x(j) < Av_x
            temp = 0;
            TvecA = [TvecA j-T1];
            T1 = j;
        end
    end
end 
    
Temp1  = (sum(TvecA)+sum(TvecB))/(length(TvecA)+length(TvecB));

nn     = length(x);

if length(TvecA) == 0

TvecA = [nn-1-TvecB(1)];

end

if length(TvecB) == 0

TvecB = [nn-1-TvecA(1)];

end

TA = sum(x > Av_x);
TB = sum(x < Av_x);

Temp1  = (sum(TvecA)+sum(TvecB))/(length(TvecA)+length(TvecB));
TempA1 = sum(TvecA)/length(TvecA)             ;
TempB1 = sum(TvecB)/length(TvecB)             ;

ACT1  = [ACT1 Temp1]  ;
ACT2  = [ACT2 N/(length(TvecA)+length(TvecB))];

ACTA1 = [ACTA1 TempA1];
ACTA2 = [ACTA2 TA/length(TvecA)];
ACTB1 = [ACTB1 TempB1];
ACTB2 = [ACTB2 TB/length(TvecB)];

end

i = Index;

Temp1 = (mean(ACT1)+mean(ACT2))/2;
ACT(i,No) = Temp1;
SD(i,No) = std((ACT1+ACT2)/2);

TempA1 = (mean(ACTA1)+mean(ACTA2))/2;
ACTA(i,No) = TempA1;
SDA(i,No) = std((ACTA1+ACTA2)/2);

TempB1 = (mean(ACTB1)+mean(ACTB2))/2;
ACTB(i,No) = TempB1;
SDB(i,No) = std((ACTB1+ACTB2)/2);

end
end

SD_ACT   = SD./ACT  ;
SDA_ACTA = SDA./ACTA;
SDB_ACTB = SDB./ACTB;

TableACT      = array2table(ACT, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})
TableSD       = array2table(SD, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})
TableSD_ACT   = array2table(SD_ACT, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})

TableACTA     = array2table(ACTA, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})
TableSDA      = array2table(SDA, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})
TableSDA_ACTA = array2table(SDA_ACTA, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})

TableACTB     = array2table(ACTB, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})
TableSDB      = array2table(SDB, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})
TableSDB_ACTB = array2table(SDB_ACTB, 'VariableNames', {'rho0', 'rho1', 'rho2', 'rho3', 'rho4', 'rho5'}, 'Rownames', {'p^e', 'p^b', 'r^e', 'r^b', 'r^p'})




