clc
clear all
close all


% parameters
k0     = 1   ;
sig_sq = 0.00712^2;

N      = 10*10^4 ; %length of time series
omega  = 1    ;
rho    = 0 ;
alpha  = 0.36 ;
beta   = 0.99 ;


Corr = zeros(5,10); % autocorr
 
% finding i,j,k
IJK = [];

Nmax = 10; % 0<i<j<k<Nmax

for i = 1:Nmax
    for j = (i+1):Nmax
        for k = (j+1):Nmax
            IJK = [IJK [i j k]'];
        end
    end
end


for Index = 1:5

Index

% random white noise
sig = sig_sq^0.5;
eps = sig*randn(N,1);

% lambda series
lambda = [];
temp = 0;
for i = 1:N
    temp1 = rho*temp+eps(i);
    lambda = [lambda temp1];
    temp = temp1;
end

% k series
k = [(alpha*beta*exp(0.5*sig_sq))^(1/(1-alpha))]; %kss to start with
temp = (alpha*beta*exp(0.5*sig_sq))^(1/(1-alpha));
for i = 1:(N-1)
    ktemp = alpha*beta*temp^alpha*exp(lambda(i));
    k = [k ktemp];
    temp = ktemp;
end

% making return and prices series
pte = alpha*beta*k.^(alpha).*exp(lambda);
ptb = beta*exp(sig_sq/2)*(alpha*beta)^(-alpha).*k.^(alpha-alpha^2).*exp((1-alpha-rho)*lambda);
rte = alpha*k.^(alpha-1).*exp(lambda);
rtb = 1./ptb-1;
rtp = rte-rtb;

Serie = [pte; ptb; rte; rtb; rtp];

i = Index;
x = Serie(i,:);

for ijk = 1:length(IJK)
    
ii = IJK(1,ijk);
jj = IJK(2,ijk);
kk = IJK(3,ijk);

x1 = x((1+ii):end)-x(1:(end-ii));
x2 = x((1+kk-jj):end)-x(1:(end-kk+jj));
x2 = x2((1+jj):end);

Len = min(length(x1),length(x2));

x1 = x1(1:Len);
x2 = x2(1:Len);

Av1 = sum(x1)/length(x1);
Sig2_x1 = sum((x1-Av1).^2)/length(x1);

Av2 = sum(x2)/length(x2);
Sig2_x2 = sum((x2-Av2).^2)/length(x2);

CorrTemp = (sum((x1-Av1).*(x2-Av2))./length(x1))/Sig2_x1^0.5/Sig2_x2^0.5;
Corr(i,ijk) = CorrTemp;

end

end

rho

Corr

Range = [min(Corr')' max(Corr')']




